function frmXOLoaded()
    frmXO:RegisterForDrag("LeftButton");
	frmXO:RegisterEvent("CHAT_MSG_ADDON");
	RegisterAddonMessagePrefix("lgohxo");
	if(IsAddOnLoaded("ELGoH")) then print("Elgoh: RaidXO Loaded"); end
	
	XOButtonArray = {};
	XOgame={};
	yourTurn=0;
	for i=1,3 do
		XOgame[i]={}
		XOButtonArray[i]={}
		for j=1,3 do
			XOgame[i][j]=0;
			XOButtonArray[i][j]=CreateFrame("Button", nil, frmXO, "UIPanelButtonTemplate");
			XOButtonArray[i][j]:RegisterForClicks("AnyUp");
			XOButtonArray[i][j]:SetScript("OnClick", function() gameMove(i,j,team); end)
			XOButtonArray[i][j]:SetPoint("TOPLEFT", "frmXO", "TOPLEFT", ((i-1)*50), -(((j-1)*50)));
			XOButtonArray[i][j]:SetWidth(50)
			XOButtonArray[i][j]:SetHeight(50)
		end
    end
end

function XOmessaged(event, ...)
	if(event=="CHAT_MSG_ADDON") then
		local prefix, msg, how, who = select(1, ...);
		if(prefix=="lgohxo") then 
			if(msg=="q") then
				print(who.." has challened you to an XO duel! Click your XO button to accept, or shift click to decline");
				pending=1;
				XOtarget=who;
			elseif(msg=="r") then
				btnXOStart:SetText(who);
				frmXO:Show();
				yourTurn=1;
				team=3;
			elseif(msg=="3" or msg=="5") then
				if(team==msg) then print("You win!") else print("You lose!"); end
			else
				x=string.sub(msg,1,1);
				y=string.sub(msg,2,2);
				XOgame[x][y]=3;
			end
		end
	end
end

function sendMove(x,y)
	SendAddonMessage("lgohxo", x..y, "WHISPER", XOtarget)
end

function XOHandshake(XOtarget, qr)
	SendAddonMessage("lgohxo", qr, "WHISPER", UnitName("target"))
end

-- pending 1=invite 2=in-XOgame, 3=finished

function XOClick()
	if(pending==0) then
		XOtarget=UnitName("target")
		if(target~=nil) then
			handshake(XOtarget, "q");
		end
	elseif(IsShiftKeyDown() and pending>0) then
		print("Elgoh: Duel Declined");
		pending=0;
		for i=1,3 do
			for j=1,3 do
				XOgame[i][j]=0;
				XOButtonArray[i][j]:SetText("");
			end
		end
	elseif(pending==1) then
		handshake(XOTarget, "r")
		btnXOStart:SetText("XO: "..XOtarget);
		pending=2;
		yourTurn=0;
		team=5;
		frmXO:Show();
		frmMain:Hide();
	elseif(pending==3) then
		for i=1,3 do
			for j=1,3 do
				XOgame[i][j]=0;
				XOButtonArray[i][j]:SetText("");
			end
		end
		pending=0;
		frmXO:Hide();
	end
end

function Victory(teamt)
	if(team==teamt) then print("You win!") else print("You lose!"); end
	SendAddonMessage("lgohxo", teamt, "WHISPER", XOtarget);
end

function gameMove(x,y,team)
if(yourTurn==1) then
	if(XOgame[x][y]==0) then XOgame[x][y]=team; end
	XOButtonArray[x][y]:SetText(team);
	XOcheck(team);
	yourTurn=0;
	sendMove(x,y)
end
end

function XOcheck(teamt)
	for i=1, 3 do
		if((XOgame[i][1] + XOgame[i][2] + XOgame[i][3])==(team*3)) then  -- horizontal
			Victory(team); 
		end
		if((XOgame[1][i] + XOgame[2][i] + XOgame[3][i])==(team*3)) then  -- vertical
			Victory(team); 
		end
	end
	if((XOgame[1][1] + XOgame[2][2] + XOgame[3][3])==(team*3)) then  -- diagonal 1
		Victory(team); 
	end
	if((XOgame[1][3] + XOgame[2][2] + XOgame[3][1])==(team*3)) then  -- diagonal 2
		Victory(team); 
	end
end